//
//  HTTPThread.h
//

#ifndef _HTTPTHREAD_H_
#define _HTTPTHREAD_H_

#include "HThrdMgr.h"

// forward reference
class   CHTTPThreadMgr ;

#include <WinINet.h>

// Return codes for the DownloadRemoteFile() function

#define HTTPTHREAD_SUCCESS          100
#define HTTPTHREAD_FAILURE          101
#define HTTPTHREAD_COULDNOTSAVEFILE 102
#define HTTPTHREAD_COULDNOTCONNECT  103
#define HTTPTHREAD_FILENOTFOUND     104

//
//  CHTTPThread Class...manages the thread which reads a file
//  from an Internet URL.
//

class CHTTPThread
{
public:
    // Construction
    CHTTPThread() ;
    ~CHTTPThread() ;

    // Initialization
    BOOL            Init(CHTTPThreadMgr *pINetThreadMgr, 
                         int iThreadNum, 
                         char *szTitle = 
                            (char *) AfxGetAppName()) ;

    BOOL            IsThreadAvailable() ;

    void	        SetThreadNum(int iThreadNum) ;

    void            ResetSession() ;

    // Get the remote file.
    void            GetRemoteFile(CString &rURL, 
                                  char *szLocalFile) ;

private:
   
    // Thread calls DownloadRemoteFile.
    static UINT     GetRemoteFileThread(LPVOID pvThread) ;

    // This is where the actually work is done.
    UINT            DownloadRemoteFile() ;

    CHTTPThreadMgr  *m_pThreadMgr ;

    CString         m_strServer ;
    CString         m_strPath ;

    char            m_szTitle[255] ;
    char            m_szLocalFile[255] ;
    char            m_szRemoteFile[512] ;
    int             m_iThreadNum ;

    CWinThread      *m_pThread ;

    HINTERNET       m_hSession ;

    static void     DebugMsg(char *szMsg) ;

} ;

#endif 
